/**
 * Copyright (c) 2009-2012 Zauber S.A. <http://zauberlabs.com/>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ar.com.zauber.leviathan.common.mock;

import java.net.URI;
import java.nio.charset.Charset;

import org.apache.commons.lang.Validate;

import ar.com.zauber.commons.dao.Transformer;

/**
 * Util para mapear request a archivos de un directorio
 * 
 * @author Juan F. Codagnone
 * @since Sep 20, 2010
 */
public class PrefixMockURIFetcher extends AbstractMockUriFetcher {
    private final Transformer<URI, String> transformer;

    /** Creates the FixedContentProvider. */
    public PrefixMockURIFetcher(final Transformer<URI, String> transformer) {
        this(transformer, Charset.defaultCharset());
    }
    

    /** Creates the FixedContentProvider. */
    public PrefixMockURIFetcher(final Transformer<URI, String> transformer,
                                final Charset charset) {
        super(charset);
        Validate.notNull(transformer);

        this.transformer = transformer;
    }

    @Override
    protected final String getDestinationURL(final URI uri) {
        return transformer.transform(uri);
    }
}
